#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <gmp.h>

int
main(int argc, char **argv)
{ 
  int flag, i, j, ii, jj, N;
  long int longzero, pmij;
  FILE *pin1, *pin2, *pout;
  mpz_t *vi, vout, vij;
  char is[1024];

  if ( argc != 4 )
  {
    fprintf(stderr,"Usage: ./adj infile1.txt infile2.txt outfile.txt.\n");
    fprintf(stderr,"The file infile1.txt should contain a matrix.\n");
    fprintf(stderr,"The file infile2.txt should contain a vector.\n");
    fprintf(stderr,"The file outfile.txt is overwritten with a vector.\n");
    return(1);
  }




  longzero = (long)(0);

  pin1 = fopen(argv[1],"r");
  pin2 = fopen(argv[2],"r");
  pout = fopen(argv[3],"w");

  fscanf(pin1,"%d",&N); 

  vi = (mpz_t *) malloc(N*sizeof(mpz_t));

  for ( i = 0 ; i < N ; i++ )
  {
    fscanf(pin2,"%1023s",is);
    mpz_init(vi[i]);
    flag = mpz_set_str(vi[i],is, 10);
    if (flag != 0)
    {
     /* If flag is not 0 then the operation failed */
      fprintf(stderr,"\n\nERROR: vector file corrupted!\n\n");
      return(1);
    }
  }

  fclose(pin2);

  mpz_init(vout);
  mpz_init(vij);

  for ( i = 0 ; i < N ; i++ )
  {
    mpz_set_ui(vout,longzero);

    for ( j = 0 ; j < N ; j++ )
    {
      fscanf(pin1,"%d %d %ld",&ii,&jj,&pmij); 
      if ( ( i != ii ) || ( j != jj ) )
      {
        fprintf(stderr,"Reading error, file corrupted?\n\n");
        fclose(pin1);
        fclose(pout);
        return(1);
      }
      mpz_set_si(vij,pmij);
      mpz_addmul(vout,vi[j],vij);
    }
    mpz_out_str(pout,10,vout);
    fprintf(pout,"\n");
  }

  fclose(pin1);
  fclose(pout);

  return(0);
}


  

